import direct.directbase.DirectStart

from panda3d.core import (CollisionTraverser,CollisionNode, 
                          CollisionHandlerQueue,CollisionRay,
                          BitMask32, Vec4, WindowProperties)
                          
from direct.gui.DirectGui import DirectEntry

from direct.directtools.DirectGeometry import LineNodePath

from camera import CamFree
camera_level = CamFree()

cursor = LineNodePath(render, 'up', 4, colorVec = Vec4(0, 1, 0, 1)) 
cursor.drawLines([((0, 0, 0), (0, 0, 1500))])      
cursor.create()

x = DirectEntry(pos = (-base.getAspectRatio()+0.05, 0, 0.9), width = 10, scale=.05, numLines = 1, focus = 0, initialText = "X")
y = DirectEntry(pos = (-base.getAspectRatio()+0.05, 0, 0.8), width = 10, scale=.05, numLines = 1, focus = 0, initialText = "Y")
z = DirectEntry(pos = (-base.getAspectRatio()+0.05, 0, 0.7), width = 10, scale=.05, numLines = 1, focus = 0, initialText = "Z")
  
def scan(task):
    if camera_level.keyMap['Mouse3'] == 0:
        if base.mouseWatcherNode.hasMouse():
            mpos = base.mouseWatcherNode.getMouse() 
            pickerRay.setFromLens(base.camNode, mpos.getX(), mpos.getY())   
            picker.traverse(render)     
            for i in xrange(pickerQ.getNumEntries()): 
                entry = pickerQ.getEntry(i)   
                xyz = entry.getSurfacePoint(render)
                cursor.setPos(xyz)
                if camera_level.keyMap['Mouse1'] == 1:
                    x.set(str(xyz[0]))
                    y.set(str(xyz[1]))
                    z.set(str(xyz[2]))
    return task.cont
            
            
taskMgr.add(scan, 'scan')

# Image size
height = 707
width = 999
            
tex = loader.loadTexture('auto.png')
map = loader.loadModel("map.egg")
map.setTexture(tex, 0)
map.setSy(height)
map.setSx(width)
map.reparentTo(render)

base.camera.setX(-height)
base.camera.setZ(width)
base.camera.lookAt(0, 0, 0)

picker = CollisionTraverser()
pickerQ = CollisionHandlerQueue()  
pickerCollN = CollisionNode('mouseRay')  
pickerCamN = base.camera.attachNewNode(pickerCollN)      
pickerCollN.setFromCollideMask(BitMask32.bit(1))
pickerCollN.setIntoCollideMask(BitMask32.allOff())   
pickerRay = CollisionRay()     
pickerCollN.addSolid(pickerRay)     
picker.addCollider(pickerCamN, pickerQ)

base.run()